SystemOrganization addCategory: #'MC2-SqueakPlatform'!

Object subclass: #MDAuthorInfo
	instanceVariableNames: ''
	classVariableNames: 'Author LastImageName'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
initialize
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:09'!
prompt
	^ ' Please enter you name and email address for Monticello2 '! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
shutDown
	LastImageName _ SmalltalkImage current imageName! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
startUp
	LastImageName = SmalltalkImage current imageName
		ifFalse: [Author _ nil]! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:24'!
value
	^ Author ifNil: 
		[Author _ MDPlatform current prompt: self prompt default: '']! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:24'!
value: aString
	"Set the name and email address of the user of the system."
	
	Author _ aString! !

Object subclass: #MDNotificationAdaptor
	instanceVariableNames: 'listeners'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/9/2008 16:56'!
default
	^ Instance ifNil: 
		[Instance _ self new. 
		Instance register]! !

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 3/9/2008 16:57'!
reset
	Instance ifNotNil: [Instance unregister].
	Instance _ nil! !

!MDNotificationAdaptor methodsFor: 'listeners' stamp: 'cwp 3/9/2008 15:21'!
addListener: anObject
	listeners add: anObject! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/10/2008 20:09'!
announce: anElement toAll: objects startingAt: start
	| listener |
	(start to: objects size) do: 
		[:i | 
		[listener _ objects at: i.
		listener ifNotNil: [listener noteElementChanged: anElement]]
			on: Halt, Exception
			do: 
				[:exc | 
				self announce: anElement toAll: objects startingAt: i+1.
				exc pass]]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 15:20'!
initialize
	listeners _ WeakSet new.
	 ! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 15:15'!
noteClassChanged: anEvent
	| element |
	element _ MDClassElement className: anEvent item name.
	self noteElementChanged: element! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 13:18'!
noteClassCommented: anEvent
	| element |
	element _ MDClassCommentElement className: (anEvent item name).
	self noteElementChanged: element! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 14:19'!
noteClassModified: anEvent

	self processClass: anEvent.
	anEvent areInstVarsModified ifTrue: [self processInstVars: anEvent].
	anEvent areClassVarsModified ifTrue: [self processClassVars: anEvent].
	anEvent areSharedPoolsModified ifTrue: [self processPools: anEvent].! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 15:52'!
noteElementChanged: anElement
	self announce: anElement toAll: listeners asArray startingAt: 1! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 15:00'!
noteMethodChanged: anEvent
	| element class |
	class := anEvent environmentAt: #class.
	element := MDMethodElement
				className: class theNonMetaClass name
				selector: (anEvent environmentAt: #selector)
				classIsMeta: class isMeta.
	self noteElementChanged: element ! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:32'!
processClass: anEvent
	| element |
	(anEvent isSuperclassModified or: [anEvent item category ~= anEvent oldItem category])
		ifTrue:
			[element _ MDClassElement className: anEvent item name.
			self noteElementChanged: element].! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:38'!
processClassVars: anEvent
	| changed element |
	changed _ self xor: anEvent classVarNames with: anEvent oldClassVarNames.
	changed do:
		[:name |
		element _ MDClassVarElement className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 15:01'!
processInstVars: anEvent
	| changed element class |
	changed _ self xor: anEvent instVarNames with: anEvent oldInstVarNames.
	changed do:
		[:name |
		class _ anEvent item isMeta ifTrue: [MDClassInstVarElement] ifFalse: [MDInstVarElement].
		element _ class className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:49'!
processPools: anEvent
	| changed element name |
	changed _ self xor: anEvent sharedPools with: anEvent oldSharedPools.
	changed do:
		[:pool |
		name _ Smalltalk keyAtValue: pool.
		element _ MDPoolImportElement className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 15:14'!
register
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofSystemChangesOfItem: #class 
		change: #Commented 
		using: #noteClassCommented:;
		
		notify: self 
		ofSystemChangesOfItem: #class 
		change: #Modified 
		using: #noteClassModified:;
		
		notify: self
		ofSystemChangesOfItem: #class
		change: #Added
		using: #noteClassChanged:;
		
		notify: self
		ofSystemChangesOfItem: #method
		using: #noteMethodChanged:.! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 13:25'!
registerAll
	SystemChangeNotifier uniqueInstance 
		notify: self ofAllSystemChangesUsing: #transcribe:! !

!MDNotificationAdaptor methodsFor: 'listeners' stamp: 'cwp 3/9/2008 15:22'!
removeListener: anObject
	listeners remove: anObject! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 13:26'!
transcribe: anEvent
	Transcript cr; show: anEvent asString! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 13:06'!
unregister
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 3/9/2008 14:37'!
xor: left with: right
	| result |
	result _ Set new.
	left do: [:ea | (right includes: ea) ifFalse: [result add: ea]].
	right do: [:ea | (left includes: ea) ifFalse: [result add: ea]].
	^ result! !

Object subclass: #MDPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 3/20/2005 01:12'!
current
	^ self new! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 6/18/2005 20:30'!
clockOffset
	^ -2498169600! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 11/17/2007 01:25'!
initials
	^ Utilities authorInitials ! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 3/9/2008 16:08'!
notifier
	^ MDNotificationAdaptor default! !

!MDPlatform methodsFor: 'user interface' stamp: 'cwp 12/28/2007 21:06'!
prompt: prompt default: default
	^ OBTextRequest
		prompt: prompt
		template: default! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 6/18/2005 20:29'!
secondClock
	^ Time primSecondsClock! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 3/2/2008 15:27'!
serializationClassMap
	^ IdentityDictionary new
		at: UndefinedObject put: MDSingletonSerializer new;
		at: True put: MDSingletonSerializer new;
		at: False put: MDSingletonSerializer new;
		at: SmallInteger put: MDSmallIntegerSerializer new;
		at: LargePositiveInteger put: MDLargeIntegerSerializer new;
		at: LargeNegativeInteger put: MDLargeIntegerSerializer new;
		at: Symbol put: MDStringSerializer new;
		at: String put: MDStringSerializer new;
		at: Array put: MDListSerializer new;
		at: Set put: MDListSerializer new;
		at: Dictionary put: MDDictionarySerializer new;
		yourself! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 11/16/2007 00:54'!
showCursor: aSymbol
	| cursor |
	cursor _ aSymbol ifNotNil: [Cursor perform: aSymbol].
	ActiveHand showTemporaryCursor: cursor! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 12/22/2006 22:25'!
systemEditor
	^ Smalltalk! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 12/28/2007 21:25'!
updateMemoProperties: properties
	properties 
		initials: Utilities authorInitials;
		author: MDAuthorInfo value! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 3/2/2008 12:19'!
variablePointersObject
	^ (ActionSequence new: 2)
		at: 1 put: #a;
		at: 2 put: #b;
		yourself! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 12/22/2007 22:27'!
withCursor: aSymbol do: aBlock
	self showCursor: aSymbol.
	^ aBlock ensure: [self showCursor: nil]! !
MDAuthorInfo initialize!
